=== debian/changelog ===
cataclysm-dda (0.H-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches and delete applied ones.
  * Bump Standards-Version to 4.7.0.

 -- Reiner Herrmann <reiner@reiner-h.de>  Thu, 19 Dec 2024 16:59:37 +0100

cataclysm-dda (0.H~rc1-1) experimental; urgency=medium

  * New upstream release candidate.
  * Drop applied patches and refresh.
  * Update copyrights.
  * Lower severity of maybe-uninitialized compiler error because of
    false-positive.
  * Adjust autopkgtest to new upstream version.

 -- Reiner Herrmann <reiner@reiner-h.de>  Thu, 15 Feb 2024 01:04:26 +0100

cataclysm-dda (0.G-5) unstable; urgency=medium

  * Fix FTBFS with GCC 14. (Closes: #1074867)

 -- Reiner Herrmann <reiner@reiner-h.de>  Mon, 29 Jul 2024 19:11:59 +0200
